<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_adminlogin.asp
' Summary  - Administration login page
' Version  - 0.7B
' Updated  - 28 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************
OPTION EXPLICIT

LogoutUser
' Do IP Address check (IP Address entered in acmsi_global.asp
bln_ipfound = False
If NotEmpty(c_ALLOWEDIP) Then
	str_ip = Request.ServerVariables("REMOTE_ADDR")
	arr_ip = Split(c_ALLOWEDIP,",")
	For int_ipcount = 0 to UBound(arr_ip)
		If Left(str_ip,Len(arr_ip(int_ipcount))) = arr_ip(int_ipcount) Then 
			bln_ipfound = True
			Exit For
		End If
	Next
	If Not bln_ipfound Then 
		LogoutUser
		Response.Redirect "."
	End If
End If
	
' variable declaration
Dim arr_server, str_scriptname
Dim arr_ip, str_ip
Dim int_ipcount, bln_ipfound
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
' Display language drop down
Sub DoLanguageList

	Dim conn, rs
	Dim str_title, str_keyword
	
	OpenDatabase conn
	
	ExecuteRecordset q_SelectTable("keyword,title","acmstbl_languages","title","","disabled",GetBoolean(False),"boolean"), conn, rs
	If Not rs.EOF Then
		Response.Write "<select name=""language"">" & vbCrLf
		Do Until rs.EOF
			str_title = rs("title")
			str_keyword = rs("keyword")
			Response.Write "<option value=""" & str_keyword & """>" & Server.HTMLEncode(str_title) & "</option>" & vbCrLf
			rs.MoveNext
		Loop
		Response.Write "</select>"
	End If
	CloseRecordset rs
	
	CloseDatabase conn
	
End Sub

' Subroutine to verify user login details
Sub ValidateUserLogin

	Dim str_username, str_password, str_access, str_language
	Dim conn, obj_command, rs, rs_access
	
	' Get form login information, and remove white space
	str_username = Trim(GetFormValue("username",""))
	str_password = Trim(GetFormValue("password",""))
	str_language = GetFormValue("language","")
	
	OpenDatabase conn
	If NotEmpty(str_language) Then 
		WriteCookie "langkeyword", str_language
		ExecuteRecordset q_SelectTable("filename","acmstbl_languages","","","keyword",str_language,"string"), conn, rs
		WriteCookie "langfilename", rs("filename")
		CloseRecordset rs
	End If
	If NotEmpty(str_username) AND NotEmpty(str_password) Then
		
		' Check if username and password match
		Set obj_command = Server.CreateObject("ADODB.Command")
		obj_command.CommandText = "SELECT username,userpassword,usergroup,super FROM acmstbl_users u" &_
								" INNER JOIN acmstbl_usergroups ug ON u.usergroup=ug.id" &_
								" WHERE u.locked=" & GetBoolean(False) & " AND ug.locked=" & GetBoolean(False) &_
								" AND username=? AND userpassword=?" &_
								" UNION" &_
								" SELECT username,userpassword,usergroup,super FROM acmstbl_users" &_
								" WHERE super=" & GetBoolean(True) &_
								" AND username=? AND userpassword=?;"
		obj_command.ActiveConnection = conn
		obj_command.CommandType = adCmdText
		obj_command.Prepared = True
    	obj_command.Parameters.Append obj_command.CreateParameter("@username",adChar,adParamInput,50)
    	obj_command.Parameters.Append obj_command.CreateParameter("@password",adChar,adParamInput,50)
		obj_command.Parameters.Append obj_command.CreateParameter("@superusername",adChar,adParamInput,50)
    	obj_command.Parameters.Append obj_command.CreateParameter("@superpassword",adChar,adParamInput,50)
    	obj_command("@username") = str_username
    	obj_command("@password") = str_password
		obj_command("@superusername") = str_username
    	obj_command("@superpassword") = str_password
		
		Set rs = obj_command.Execute
		If Not rs.EOF Then
			If (rs("username") = str_username) AND (rs("userpassword") = str_password) Then
				' Successful login; write user information to cookies
				WriteCookie "username",rs("username")
				WriteCookie "super",CBool(rs("super"))
				If Not rs("super") Then
					WriteCookie "usergroup", rs("usergroup")
					ExecuteRecordset q_SelectTable("menukeyword","acmstbl_usergroupaccess","menukeyword","","usergroupid",rs("usergroup"),"number"), conn, rs_access
					Do Until rs_access.EOF
						str_access = str_access & rs_access("menukeyword")
						rs_access.MoveNext
						If Not rs_access.EOF Then str_access = str_access & ","
					Loop
					CloseRecordset rs_access
					WriteCookie "accessareas", str_access
				End If
				' Set cookie expiration to 60 minutes
				Response.Cookies("acms").Expires = DateAdd("n",60,Now())
				Set obj_command = Nothing
				CloseRecordset rs
				CloseDatabase conn

				Response.Redirect "acms_adminhome.asp"
			End If
		End If
		
		' Unsuccessful login
		SetError GetLanguage("lang_validationfailed"), c_LOGINPAGE

		Set obj_command = Nothing
		CloseRecordset rs

	End If
	CloseDatabase conn

End Sub
' end functions and subroutines

' admin template areas
Sub DoMainAdminContent ()

	If NotEmpty(GetFormValue("submit","")) Then ValidateUserLogin
%>
	<div class="breadcrumb"><a href=".">Website...</a>&nbsp; Administration</div>
	<form method="post" action="<%=c_LOGINPAGE%>" name="frm_login" onsubmit="return validate_login(this)">
	<table class="form">
		<tr>
			<th>Username</th>
			<td><input type="text" name="username" class="textbox" onblur="onblurvalidate(this);" /> *</td>
		</tr>
		<tr>
			<th>Password</th>
			<td><input type="password" name="password" class="textbox" onblur="onblurvalidate(this);" /> *</td>
		</tr>
		<tr>
			<th>Language</th>
			<td><% DoLanguageList %></td>
		</tr>
		<tr>
			<td>&nbsp;</td>
			<td><input type="submit" name="submit" value="Login" class="submitbtn" /></td>
		</tr>
	</table>
	</form>
<%
End Sub

Sub DoAdminInstructions ()

End Sub
' end admin template areas
%>