<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_filelist.asp
' Summary  - File manager and uploader
' Version  - 0.7B
' Updated  - 28 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("filemanager")

' variable declaration
Dim str_directory
Dim str_displaydirectory, str_rootdirectory
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_snippets.asp"-->
<!--#include file="includes/acmsi_templates.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
Sub DoDirectoryList(directory)

	Dim fs, folder, subfolder, str_foldername, str_folderlink
		
	ReadDirectory directory, fs, folder
	If lcase(directory) <> lcase(Server.MapPath(".")) Then
		Response.Write "<tr>" & vbCrLf
		If Instr(directory,"\") = 0 Then
			str_folderlink = "."
		Else
			str_folderlink = fs.GetParentFolderName(directory)
		End If
		DoDataOutput "acms_filelist.asp?directory=" & Server.URLEncode(str_folderlink),"..","","maincol smlindent highlight","td",""
		Response.Write "</tr>" & vbCrLf
	End If
	
	For Each subfolder In folder.SubFolders
		str_foldername = Replace(lcase(subfolder),lcase(directory) & "\","")
		Response.Write "<tr>" & vbCrLf
		DoDataOutput "acms_filelist.asp?directory=" & Server.URLEncode(subfolder),Server.HTMLEncode(str_foldername),"","maincol smlindent highlight","td",""
		Response.Write "</tr>" & vbCrLf
	Next
	CloseFSO_Folder fs, folder

End Sub

Sub DoFileList(directory)

	Dim fs, folder, file_item, str_filename, str_relativefile
	Dim	arr_filetypes, arr_viewfiletypes, arr_editfiletypes
	
	ReadDirectory directory, fs, folder
	For Each file_item In folder.Files
		str_filename = file_item.Name
		SplitValue c_FILETYPESEDITABLE & "," & c_FILETYPESVIEWABLE & "," & c_TEMPLATEFILETYPE, arr_filetypes, ","
		SplitValue c_FILETYPESEDITABLE & "," & c_TEMPLATEFILETYPE, arr_editfiletypes, ","
		SplitValue c_FILETYPESVIEWABLE, arr_viewfiletypes, ","
		If ValueInArray(fs.GetExtensionName(directory & "\" & str_filename),arr_filetypes) Then
			Response.Write "<tr>" & vbCrLf
			If ValueInArray(fs.GetExtensionName(directory & "\" & str_filename),arr_viewfiletypes) Then
				DoDataOutput "acms_fileview.asp?directory=" & Server.URLEncode(directory) & "&amp;filename=" & Server.URLEncode(str_filename),Server.HTMLEncode(str_filename),"","maincol smlindent","td",""
			ElseIf ValueInArray(fs.GetExtensionName(directory & "\" & str_filename),arr_editfiletypes) Then
				DoDataOutput "acms_fileedit.asp?directory=" & Server.URLEncode(directory) & "&amp;filename=" & Server.URLEncode(str_filename),Server.HTMLEncode(str_filename),"","maincol smlindent","td",""
			End If
			Response.Write "</tr>" & vbCrLf
		ElseIf GetCookie("super") Then
			Response.Write "<tr>" & vbCrLf
			DoDataOutput "",Server.HTMLEncode(str_filename),"","maincol smlindent al","td",""
			Response.Write "</tr>" & vbCrLf
		End If		
	Next
	CloseFSO_Folder fs, folder

End Sub

Sub GetDirectoryInformation ()

	str_directory = GetValue("directory","")
	If str_directory = "" Then
		str_directory = Server.MapPath(".")
	ElseIf Instr(lcase(str_directory),lcase(Server.MapPath("."))) = 0 Then
		str_directory = Server.MapPath(".")
	End If

	If lcase(str_directory) = lcase(Server.MapPath(".")) Then
		str_displaydirectory = "root"
	Else
		str_rootdirectory = "<a href=""acms_filelist.asp?directory=" & Server.URLEncode(Server.MapPath(".")) & """>root...</a>&nbsp;"
		str_displaydirectory = Replace(lcase(str_directory),lcase(Server.MapPath(".") & "\"),"")
	End If
	
End Sub

Sub DoMainAdminContent ()
	OpenDatabase conn
	GetDirectoryInformation
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=str_rootdirectory%> <%=Server.HTMLEncode(str_displaydirectory)%></div>
	<table class="tree">
		<tr>
			<td class="add"><a href="acms_fileedit.asp?directory=<%=str_directory%>"><%=GetLanguage("lang_addfile")%></a></td>
		</tr>
		<% DoDirectoryList str_directory %>
		<% DoFileList str_directory %>
	</table>
	<table class="form auto">
		<tr>
			<td>
				<form method="post" action="acms_fileaction.asp" enctype="multipart/form-data">
					<input type="text" name="subdirectory" value="" class="textbox" />
					<input type="hidden" name="directory" value="<%=Server.HTMLEncode(str_directory)%>" />
					<input type="hidden" name="action" value="create" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_createdirectory")%>" class="submitbtn" />
				</form>
			</td>
		</tr>
		<tr>
			<td>
				<form method="post" action="acms_fileaction.asp" enctype="multipart/form-data">
					<input type="file" name="File1" value="" class="textbox" />
					<input type="hidden" name="directory" value="<%=Server.HTMLEncode(str_directory)%>" />
					<input type="hidden" name="action" value="upload" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_uploadfile")%>" class="submitbtn" />
				</form>
			</td>
		</tr>
	</table>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_menu_filemanager")%></h2>
	<div id="instructions">
		<p><strong>NOTE:</strong> This facility should not be used as a replacement for FTP, and should only be used for
		text edits, and minor file uploads.  It is recommended that FTP should be used when possible.</p>
		<p>Directories are highlighted in green, and placed at the top of the page. To go back to the parent directory, 
		click the ".." link at the top. To create a directory, enter the new directory name in the field at the bottom and 
		click on "Create Directory" button.</p>
		<p>To create/edit a file, click on the "Add File" link at the top of the page or the filename link; you can only 
		create/edit files with file	extensions specified in c_FILETYPESEDITABLE (acmsi_global.asp).</p>
		<p>Similarly, to view a file, click on the filename of the file you wish to view; you can only view files with
		file extensions specified in c_FILETYPESVIEWABLE (acmsi_global.asp).</p>
		<p>To upload a file, click on the "Browse.." button and select the file you wish to upload; click "Upload File" to
		complete the process.  Depending on the file size and connection speed, the uploading time may vary.  It is also
		important to note that Windows 2003 Server has an upload limit set and therefore you may not be able to upload any
		files more than 204800 bytes (~200Kb).</p>
		<p>Super users can upload any type of file, while normal users can only upload files specified in c_FILETYPESEDITABLE,
		c_FILETYPESVIEWABLE and c_TEMPLATEFILETYPE.</p>
	</div>
<%
End Sub
%>