<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_menuedit.asp
' Summary  - Edit menu details
' Version  - 0.7B
' Updated  - 28 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser(c_SUPERONLYACCESS)

' variable declaration
Dim int_menuid, int_parentid
Dim str_menutitle, str_filename, str_keyword
Dim bln_hide, bln_core
Dim str_corechecked, str_hidechecked
Dim str_action, str_submittext, str_breadcrumb
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' content specific functions and subroutines
Sub DoMenuList(parentid, level, selectedid, menuid)
	
	Dim int_menuid, str_menutitle, str_selectedparent
	Dim str_prefix
	Dim rs, i
	
	ExecuteRecordset q_SelectTable("id,title","acmstbl_menus","core,title","","parentid",parentid,"number"), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			int_menuid = rs("id")
			str_menutitle = rs("title")

			str_prefix = ""
			For i = 1 To level
				str_prefix = "--" & str_prefix
			Next
			str_selectedparent = ""
			If CLng(int_menuid) = CLng(selectedid) Then str_selectedparent = " selected=""selected"""
			If (CLng(parentid) <> CLng(menuid)) And (CLng(int_menuid) <> CLng(menuid)) Then 
				Response.Write "	<option value=""" & int_menuid & """" & str_selectedparent & ">" & str_prefix & " " & str_menutitle & "</option>" & vbCrLf
				DoMenuList int_menuid, level + 1, selectedid, menuid
			End If
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub

Sub GetMenuInformation ()
	
	Dim rs
	int_menuid = GetValue("id",-1)
		
	If int_menuid < 0 Then
		str_action = "add"
		str_submittext = GetLanguage("lang_add")
		str_breadcrumb = GetLanguage("lang_addmenu")
	Else
		str_action = "update"
		str_submittext = GetLanguage("lang_update")
		OpenRecordset q_SelectTable("*","acmstbl_menus","","","id",int_menuid,"number"), conn, rs
		If Not rs.EOF Then
			str_menutitle = rs("title")
			str_filename = rs("filename")
			int_parentid = rs("parentid")
			str_keyword = rs("keyword")
			str_breadcrumb = Server.HTMLEncode(str_menutitle)
			bln_hide = CBool(rs("hide"))
			bln_core = CBool(rs("core"))
			If bln_hide Then str_hidechecked = " checked=""checked"""
			If bln_core Then str_corechecked = " checked=""checked"""
		End If
		CloseRecordset rs
	End If
	
End Sub

' Content
Sub DoMainAdminContent ()
	OpenDatabase conn
	GetMenuInformation
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <a href="acms_menulist.asp"><%=GetLanguage("lang_menus")%>...</a>&nbsp; <%=str_breadcrumb%></div>
	<form method="post" action="acms_menuaction.asp" name="frm_menu" onsubmit="return validate_menu(this)">
		<input type="hidden" name="id" value="<%=int_menuid%>" />
		<input type="hidden" name="action" value="<%=str_action%>" />
		<table class="form">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td><input type="text" name="title" value="<%=str_menutitle%>" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td><input type="text" name="keyword" value="<%=str_keyword%>" class="textbox" onblur="xmlvalidate('acmstbl_menus','id',form.id.value,'keyword',this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_filename")%></th>
				<td><input type="text" name="filename" value="<%=str_filename%>" class="textbox" /></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_parent")%></th>
				<td>
					<select name="parent" size="1">
						<option value="0"><%=GetLanguage("lang_toplevel")%></option>
						<% DoMenuList 0, 0, int_parentid, int_menuid %>
					</select>
				</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_core")%></th>
				<td><input type="checkbox" name="core" value="True"<%=str_corechecked%> /></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_hide")%></th>
				<td><input type="checkbox" name="hide" value="True"<%=str_hidechecked%> /></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="<%=str_submittext%>" class="submitbtn" />
				</td>
			</tr>
		</table>
	</form>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<table class="tbl_instructions">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td>The name of the snippet, and only used as an identifier in the admin. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td>A simplified and unique name for the menu item utilising only alphanumerical characters (no spaces); 
				this is used as a key to check user permissions. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_filename")%></th>
				<td>The file for the menu item to link to.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_parent")%></th>
				<td>Create the menu item as a sub-menu of an existing menu item, or set to "Top Level" to set it as a main menu item.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_core")%></th>
				<td>Set the menu item as a core menu item; cannot be hidden or deleted in the menu list.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_hide")%></th>
				<td>Hide the menu item from being generated in the top navigation bar.</td>
			</tr>
		</table>
	</div>
<%
End Sub
%>