<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_pagelist.asp
' Summary  - Displays a list of pages in the database
' Version  - 1.0B
' Updated  - 21 July 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("pages")

' variable declaration
Dim int_pageid, str_pagetitle, str_keyword, str_filename, str_url, int_parentid, int_ordinal, bln_hide
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_pages.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
' Recursive subroutine to generate the page list tree
Sub DoPageTree(parentid, level)
	
	Dim rs, rs_child
	ExecuteRecordset q_SelectTable("*","acmstbl_pages","ordinal,id","","parentid",parentid,"number"), conn, rs

	If Not rs.EOF Then
		Do Until rs.EOF
			' Put data into variables
			int_pageid = rs("id")
			str_pagetitle = rs("title")
			str_keyword = rs("keyword")
			str_filename = rs("filename")
			str_url = rs("url")
			int_parentid = rs("parentid")
			int_ordinal = rs("ordinal")
			bln_hide = CBool(rs("hide"))
			
			Response.Write "<tr>" & vbCrLf
			DoDataOutput "acms_pageedit.asp?parentid=" & int_pageid,"<img src=""images/admin/add.gif"" alt=""" & GetLanguage("lang_add") & """ title=""" & GetLanguage("lang_add") & """ />","","icon","td",""
			DoDataOutput "acms_pageaction.asp?id=" & int_pageid & "&amp;parent=" & int_parentid & "&amp;ordinal=" & int_ordinal & "&amp;action=moveup","<img src=""images/admin/up.gif"" alt=""" & GetLanguage("lang_moveup") & """ title=""" & GetLanguage("lang_moveup") & """ />","","icon","td",""
			DoDataOutput "acms_pageaction.asp?id=" & int_pageid & "&amp;parent=" & int_parentid & "&amp;ordinal=" & int_ordinal & "&amp;action=movedn","<img src=""images/admin/down.gif"" alt=""" & GetLanguage("lang_movedown") & """ title=""" & GetLanguage("lang_movedown") & """ />","","icon","td",""

			' If page is Top Level, will not display "move to parent" button
			If parentid > 0 Then
				DoDataOutput "acms_pageaction.asp?id=" & int_pageid & "&amp;parent=" & int_parentid & "&amp;ordinal=" & int_ordinal & "&amp;action=movetoparent","<img src=""images/admin/toparent.gif"" alt=""" & GetLanguage("lang_movetoparent") & """ title=""" & GetLanguage("lang_movetoparent") & """ />","","icon","td",""
			Else
				DoDataOutput "","&nbsp;","","icon","td",""
			End If

			DoDataOutput "acms_pageedit.asp?id=" & int_pageid,Server.HTMLEncode(str_pagetitle),"padding-left:" & level*20 & "px","maincol","td",""

			' Determine which field to use for the view link
			If NotEmpty(str_filename) Then
				DoDataOutput str_filename,"<img src=""images/admin/view.gif"" alt=""" & GetLanguage("lang_view") & """ title=""" & GetLanguage("lang_view") & """ />","","icon","td","_blank"
			ElseIf NotEmpty(str_url) Then
				DoDataOutput str_url,"<img src=""images/admin/view.gif"" alt=""" & GetLanguage("lang_view") & """ title=""" & GetLanguage("lang_view") & """ />","","icon","td","_blank"
			Else
				DoDataOutput "default.asp?page=" & str_keyword,"<img src=""images/admin/view.gif"" alt=""" & GetLanguage("lang_view") & """ title=""" & GetLanguage("lang_view") & """ />","","icon","td","_blank"
			End If
			
			DoDataOutput "acms_pageaction.asp?id=" & int_pageid & "&amp;action=duplicate","<img src=""images/admin/duplicate.gif"" alt=""" & GetLanguage("lang_duplicate") & """ title=""" & GetLanguage("lang_duplicate") & """ />","","icon","td",""
			
			' If hidden, show hidden button
			If bln_hide Then
				DoDataOutput "acms_pageaction.asp?id=" & int_pageid & "&amp;action=unhide","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_unhide") & """ title=""" & GetLanguage("lang_unhide") & """ />","","icon","td",""
			Else
				DoDataOutput "acms_pageaction.asp?id=" & int_pageid & "&amp;action=hide","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_hide") & """ title=""" & GetLanguage("lang_hide") & """ />","","icon","td",""
			End If

			' Check if page has children, if children exists, delete button is not shown
			ExecuteRecordset q_SelectTable("id","acmstbl_pages","","","parentid",int_pageid,"number"), conn, rs_child
			If rs_child.EOF Then
				DoDataOutput "javascript:confirmdelete('acms_pageaction.asp?id=" & int_pageid & "&amp;ordinal=" & int_ordinal & "&amp;parent=" & int_parentid & "&amp;action=delete','" & str_pagetitle & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
			Else
				DoDataOutput "","&nbsp;","","icon","td",""
			End If
			
			CloseRecordset rs_child
			Response.Write "</tr>" & vbCrLf
			DoPageTree int_pageid, level + 1 
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub
' end functions and subroutines

' admin template areas
Sub DoMainAdminContent ()
	OpenDatabase conn
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=GetLanguage("lang_menu_pages")%></div>
	<table class="tree">
		<tr>
			<td colspan="8" class="add"><a href="acms_pageedit.asp"><%=GetLanguage("lang_addpage")%></a></td>
		</tr>
		<% DoPageTree 0,0 %>
	</table>
	<table class="form auto">
		<tr>
			<td>
				<form method="post" action="acms_pageaction.asp">
					<input type="hidden" name="action" value="generateall" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_generateallpages")%>" class="submitbtn" />
				</form>
			</td>
			<td>
				<form method="post" action="acms_pageaction.asp">
					<input type="hidden" name="action" value="generateallmod" />
					<input type="submit" name="submit" value="<%=GetLanguage("lang_generateallmodified")%>" class="submitbtn" />
				</form>
			</td>
		</tr>
	</table>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<p>Above shows a list of pages that have been created; click on the page name to edit the contents of the
		corresponding page. See below for explanations of the buttons shown in the page list.</p>
		<p>To generate all pages, regardless whether the contents of the page has been modified, click the "Generate All Pages"
		button.  To only generate pages that have been modified, click the "Generate All Modified" button.</p>
		<table class="tbl_instructions">
			<tr>
				<td><img src="images/admin/add.gif" alt="Add" title="Add" width="15" height="15" /></td>
				<td>Add a sub-page</td>
			</tr>
			<tr>
				<td><img src="images/admin/up.gif" alt="Up" title="Up" width="15" height="15" /></td>
				<td>Move the page order up</td>
			</tr>
			<tr>
				<td><img src="images/admin/down.gif" alt="Down" title="Down" width="15" height="15" /></td>
				<td>Move the page order down</td>
			</tr>
			<tr>
				<td><img src="images/admin/toparent.gif" alt="Move to parent" title="Move to parent" width="15" height="15" /></td>
				<td>Move the page up a level</td>
			</tr>
			<tr>
				<td><img src="images/admin/view.gif" alt="View" title="View" width="15" height="15" /></td>
				<td>View the page/URL</td>
			</tr>
			<tr>
				<td><img src="images/admin/duplicate.gif" alt="Duplicate" title="Duplicate" width="24" height="15" /></td>
				<td>Duplicate the page</td>
			</tr>
			<tr>
				<td><img src="images/admin/empty.gif" alt="Unhide" title="Unhide" width="15" height="15" /></td>
				<td>Indicates page is currently hidden; click to unhide the page</td>
			</tr>
			<tr>
				<td><img src="images/admin/full.gif" alt="Hide" title="Hide" width="15" height="15" /></td>
				<td>Indicates page is currently accessible; click to hide the page</td>
			</tr>
			<tr>
				<td><img src="images/admin/cross.gif" alt="Delete" title="Delete" width="15" height="15" /></td>
				<td>Delete page and its content; for precaution, deletion of parent pages is not allowed</td>
			</tr>
		</table>
	</div>
<%
End Sub
' end admin template areas
%>