<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_snippetedit.asp
' Summary  - Edit snippet details; lists pages and content using the snippet
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("snippets")

' variable declaration
Dim int_snippetid, str_snippettitle, str_snippet, bln_hide, str_keyword, bln_template
Dim str_hidechecked
Dim int_pageid, str_pagetitle, int_contentid, str_contenttitle
Dim str_action, str_submittext, str_breadcrumb
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_snippets.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files
Sub DoContentList()

	Dim rs
	Dim bln_found
	Dim int_pageid, int_contentid, int_prevpageid
	Dim str_pagetitle, str_contenttitle
	
	bln_found = False
	ExecuteRecordset q_SelectInnerJoin("acmstbl_pages.id as PID,acmstbl_pages.title as PT,acmstbl_content.id as CID,acmstbl_content.title as CT","acmstbl_pages","acmstbl_pages.id,acmstbl_content.title",_
									"acmstbl_content.contentbody LIKE '%{acms:snp(" & str_keyword & ")%'","","","","acmstbl_content","id","pageid"), conn, rs
	
	Do Until rs.EOF
		int_pageid = rs("PID")
		str_pagetitle = rs("PT")
		int_contentid = rs("CID")
		str_contenttitle = rs("CT")
		bln_found = True
		
		Response.Write "<tr>" & vbCrLf
		If CLng(int_prevpageid) <> CLng(int_pageid) Then
			Response.Write "	<td class=""al""><a href=""acms_pageedit.asp?id=" &int_pageid & "&amp;pageid=" & int_pageid & """>" & Server.HTMLEncode(str_pagetitle) & "</a></td>" & vbCrLf
		Else
			Response.Write "	<td>&nbsp;</td>" & vbCrLf
		End If
		Response.Write "	<td class=""al""><a href=""acms_contentedit.asp?id=" & int_contentid & "&amp;pageid=" & int_pageid & """>" & Server.HTMLEncode(str_contenttitle) & "</a></td>" & vbCrLf
		Response.Write "</tr>" & vbCrLf
		
		int_prevpageid = int_pageid
		rs.MoveNext
	Loop
	
	If Not bln_found Then
		Response.Write "<tr>" & vbCrLf
		Response.Write "	<td class=""smlindent al"" colspan=""2"">No pages use this snippet (nested snippets will not appear on this list)</td>"
		Response.Write "</tr>" & vbCrLf
	End If
	CloseRecordset rs

End Sub

' content specific functions and subroutines
Sub GetSnippetInformation ()
	
	Dim rs
	int_snippetid = GetValue("id",0)
	int_pageid = GetValue("pageid",0)
	int_contentid = GetValue("contentid",0)
	
	If int_snippetid = 0 Then
		str_action = "add"
		str_submittext = GetLanguage("lang_add")
		str_breadcrumb = GetLanguage("lang_addsnippet")
	Else
		str_action = "update"
		str_submittext = GetLanguage("lang_update")
		OpenRecordset q_SelectTable("*","acmstbl_snippets","","","id",int_snippetid,"number"), conn, rs
		If Not rs.EOF Then
			int_snippetid = rs("id")
			str_snippettitle = rs("title")
			str_breadcrumb = Server.HTMLEncode(str_snippettitle)
			str_snippet = rs("snippet")
			str_keyword = rs("keyword")
			bln_hide = CBool(rs("hide"))
			If bln_hide Then str_hidechecked = " checked=""checked"""
		End If
		CloseRecordset rs
		
		If int_pageid > 0 Then
			OpenRecordset q_SelectTable("title","acmstbl_pages","","","id",int_pageid,"number"), conn, rs
			If Not rs.EOF Then 
				str_pagetitle = rs("title")
				str_breadcrumb = "<a href=""acms_pageedit.asp?id=" & int_pageid & """>" & Server.HTMLEncode(str_pagetitle) & "...</a>&nbsp; " & str_breadcrumb
			End If
			CloseRecordset rs
		ElseIf int_contentid > 0 Then
			OpenRecordset q_SelectTable("title","acmstbl_content","","","id",int_contentid,"number"), conn, rs
			If Not rs.EOF Then 
				str_contenttitle = rs("title")
				str_breadcrumb = "<a href=""acms_contentedit.asp?id=" & int_contentid & """>" & Server.HTMLEncode(str_contenttitle) & "...</a>&nbsp; " & str_breadcrumb
			End If
			CloseRecordset rs
		End If
	End If
	
End Sub

' Content
Sub DoMainAdminContent ()
	OpenDatabase conn
	GetSnippetInformation
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <a href="acms_snippetlist.asp"><%=GetLanguage("lang_menu_snippets")%>...</a>&nbsp; <%=str_breadcrumb%></div>
	<form method="post" action="acms_snippetaction.asp" onsubmit="return validate_snippet(this);" name="frm_snippet">
		<% DoEditorSave "frm_snippet" %>
		<input type="hidden" name="id" value="<%=int_snippetid%>" />
		<input type="hidden" name="pageid" value="<%=int_pageid%>" />
		<input type="hidden" name="action" value="<%=str_action%>" />
		<table class="form">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td><input type="text" name="title" value="<%=str_snippettitle%>" class="textbox" onblur="onblurvalidate(this);" /> *</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td><input type="text" name="keyword" value="<%=str_keyword%>" class="textbox" onblur="xmlvalidate('acmstbl_snippets','id',form.id.value,'keyword',this);" /> *</td>
			</tr>
			<tr><th colspan="2"><%=GetLanguage("lang_snippet")%></th></tr>
			<tr><td colspan="2"><% DoEditor "frm_snippet", "content", str_snippet %></td></tr>
			<tr>
				<th><%=GetLanguage("lang_hide")%></th>
				<td><input type="checkbox" name="hide"<%=str_hidechecked%> value="True" /></td>
			</tr>
			<tr>
				<td>&nbsp;</td>
				<td>
					<input type="submit" name="submit" value="<%=str_submittext%>" class="submitbtn" onclick="save()" />
				</td>
			</tr>
		</table>
	</form>
	<% If int_snippetid > 0 Then %>
	<h2><%=GetLanguage("lang_content")%></h2>
	<table class="tree">
		<tr>
			<th width="150"><%=GetLanguage("lang_page")%></th>
			<th><%=GetLanguage("lang_content")%></th>
		</tr>
		<% DoContentList %>
	</table>
	<% End If %>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<h3><%=GetLanguage("lang_snippet")%></h3>
		<table class="tbl_instructions">
			<tr>
				<th><%=GetLanguage("lang_title")%></th>
				<td>The name of the snippet, and only used as an identifier in the admin. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_keyword")%></th>
				<td>A simplified and unique name for the snippet utilising only alphanumerical characters (no spaces); 
				this is used as a key to use for page content.  If the keyword entered is "test", enter {acms:snp(test)} to
				generate content of this snippet. <strong>Required</strong></td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_snippet")%></th>
				<td>The HTML code of the content.</td>
			</tr>
			<tr>
				<th><%=GetLanguage("lang_hide")%></th>
				<td>Hide the snippet from being generated, nested snippets will also not be shown.</td>
			</tr>
		</table>
		<h3><%=GetLanguage("lang_content")%></h3>
		<p>This area lists the pages and the content blocks that use the current snippet.  To edit the page or content, 
		click on the title of the page or content.  Note that content with nested snippets will not be listed in this area.</p>
	</div>
<%
End Sub
%>