<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_templateaction.asp
' Summary  - Handles templates actions
' Version  - 1.0B
' Updated  - 21 July 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("templates")

' variable declaration
Dim int_templateid, str_filename, str_templatetitle, str_content, int_mode, int_pageid
Dim str_action, str_redirect, str_msg
Dim fs, folder, file_item
Dim conn, rs, rs_page, rs_content
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_snippets.asp"-->
<!--#include file="includes/acmsi_pages.asp"-->
<!--#include file="includes/acmsi_templates.asp"-->
<%

' get form values
str_action = GetValue("action","")
int_templateid = GetValue("id",0) 
str_filename= GetValue("filename","") 
str_templatetitle = GetValue("title","") 
str_content = GetValue("content","")
int_mode = GetValue("mode",0)
int_pageid = GetValue("pageid",0)

OpenDatabase conn
Select Case lcase(str_action)

	Case "add"

		Select Case int_mode
		
			Case 1
				' Add data
				int_templateid = q_InsertSnippet(conn,str_templatetitle,str_content,"",True,False)
				str_redirect = "acms_templateedit.asp?id=" & int_templateid & "&mode=1"
			
			Case 2
				' Check if filename already exists
				ReadDirectory "templates", fs, folder
				For Each file_item In folder.Files
					If str_templatetitle = file_item.Name Then 
						CloseFSO_Folder fs, folder
						SetError GetLanguage("lang_filenameexists"), "acms_templateedit.asp?mode=2"
					End If
				Next
				CloseFSO_Folder fs, folder
			
				' Save data to file
				If Instr(str_templatetitle,".") = 0 Then str_templatetitle = str_templatetitle & "." & c_TEMPLATEFILETYPE
				WriteFile "templates/" & str_templatetitle, str_content
				str_redirect = "acms_templateedit.asp?filename=" & Server.URLEncode(str_templatetitle) & "&mode=2"
				
		End Select
		str_msg = GetLanguage("lang_templateadded")
			
	Case "update"
			
		Select Case int_mode
		
			Case 1
				' Update data
				q_UpdateSnippet conn,int_templateid,str_templatetitle,str_content,"",True,False 
				str_redirect = "acms_templateedit.asp?id=" & int_templateid & "&mode=1"
				
				ExecuteRecordset q_SelectTable("id","acmstbl_pages","","","template_db",int_templateid,"number"), conn, rs
				Do Until rs.EOF
					q_SetModifiedPage conn,rs("id"),True
					rs.MoveNext
				Loop
				CloseRecordset rs
			
			Case 2
				' Check if filename already exists
				If str_templatetitle <> str_filename Then
					ReadDirectory "templates", fs, folder
					For Each file_item In folder.Files
						If str_templatetitle = file_item.Name Then
							CloseFSO_Folder fs, folder 
							SetError GetLanguage("lang_filenameexists"), "acms_templateedit.asp?file=" & str_filename & "&mode=2"
						End If
					Next
					CloseFSO_Folder fs, folder
				End If
			
				' Save data to file
				WriteFile "templates/" & str_templatetitle, str_content
				
				ExecuteRecordset q_SelectTable("id","acmstbl_pages","","","template_file",str_filename,"string"), conn, rs
				Do Until rs.EOF
					q_SetModifiedPage conn,rs("id"),True
					rs.MoveNext
				Loop
				CloseRecordset rs
		
				str_redirect = "acms_templateedit.asp?filename=" & str_templatetitle & "&mode=2"
				
		End Select
		
		str_msg = GetLanguage("lang_templateupdated")

	
	Case "delete"
			
		Select Case int_mode
		
			Case 1
				OpenUpdateRecordset q_SelectTable("modified,template_db","acmstbl_pages","","","template_db",int_templateid,"number"), conn, rs
				Do Until rs.EOF
					rs("modified") = GetBoolean(True)
					rs("template_db") = 0
					rs.Update
					rs.MoveNext
				Loop
				CloseRecordset rs
			
				ExecuteRecordset q_DeleteTable("acmstbl_snippets","id",int_templateid,"number"), conn, rs
				
			Case 2
				OpenUpdateRecordset q_SelectTable("modified,template_file","acmstbl_pages","","","template_file",str_filename,"string"), conn, rs
				Do Until rs.EOF
					rs("modified") = GetBoolean(True)
					rs("template_file") = ""
					rs.Update
					rs.MoveNext
				Loop
				CloseRecordset rs
				
				DeleteFile "templates/" & str_filename
				
		End Select
		
		str_redirect = "acms_templatelist.asp"
		str_msg = GetLanguage("lang_templatedeleted")
		
	Case "movetodb"
	
		If int_mode = 2 Then
			' Add data
			int_templateid = q_InsertSnippet(conn,str_filename,ReadFile("templates/" & str_filename),"",True,False)
		
			OpenUpdateRecordset q_SelectTable("template_db,template_file","acmstbl_pages","","","template_file",str_filename,"string"), conn, rs
			Do Until rs.EOF
				rs("template_db") = int_templateid
				rs("template_file") = ""
				rs.Update
				rs.MoveNext
			Loop
			CloseRecordset rs

			DeleteFile "templates/" & str_filename
				
			str_redirect = "acms_templatelist.asp"
			
		End If
		
	Case "movetofile"
	
		If int_mode = 1 Then
			' Add data
			ExecuteRecordset q_SelectTable("snippet,title","acmstbl_snippets","","","id",int_templateid,"number"), conn, rs
			If Not rs.EOF Then
				str_content = rs("snippet")
				str_filename = rs("title")
				If Instr(str_filename,".") = 0 Then str_filename = str_filename & "." & c_TEMPLATEFILETYPE
			End If
			CloseRecordset rs
		
			OpenUpdateRecordset q_SelectTable("template_db,template_file","acmstbl_pages","","","template_db",int_templateid,"number"), conn, rs
			Do Until rs.EOF
				rs("template_db") = 0
				rs("template_file") = str_filename
				rs.Update
				rs.MoveNext
			Loop
			CloseRecordset rs

			WriteFile "templates/" & str_filename, str_content
			ExecuteRecordset q_DeleteTable("acmstbl_snippets","id",int_templateid,"number"), conn, rs
			str_redirect = "acms_templatelist.asp"
		End If
	
	Case "settemplate"
	
		Call ValidateUser("pages")
		
		Select Case int_mode
		
			Case 1
				OpenUpdateRecordset q_SelectTable("template_db,template_file","acmstbl_pages","","","id",int_pageid,"number"), conn, rs
				If Not rs.EOF Then
					rs("template_db") = int_templateid
					rs("template_file") = ""
					rs.Update
				End If
				CloseRecordset rs
				str_redirect = "acms_templateedit.asp?id=" & int_templateid & "&mode=1"
			
			Case 2
				OpenUpdateRecordset q_SelectTable("template_db,template_file","acmstbl_pages","","","id",int_pageid,"number"), conn, rs
				If Not rs.EOF Then
					rs("template_db") = 0
					rs("template_file") = str_filename
					rs.Update
				End If
				CloseRecordset rs
				str_redirect = "acms_templateedit.asp?filename=" & Server.URLEncode(str_filename) & "&mode=2"
				
		End Select
		
	Case "duplicate"
	
		Select Case int_mode
		
			Case 1
				q_DuplicateDBTemplate conn, int_templateid
			
			Case 2
				DuplicateFileTemplate str_filename
			
		End Select
		str_redirect = GetReferPage
		str_msg = GetLanguage("lang_templateduplicated")
	
	Case Else
	
		str_redirect = "acms_templatelist.asp"

End Select
CloseDatabase conn

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>