<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_templatelist.asp
' Summary  - Lists the templates in the database and in the templates folder
' Version  - 1.0B
' Updated  - 21 July 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("templates")

' variable declaration
Dim int_templateid, str_templatetitle
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_snippets.asp"-->
<!--#include file="includes/acmsi_templates.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
Sub DoDatabaseTemplateList()
	
	Dim rs, rs_child
	
	ExecuteRecordset q_SelectTable("id,title","acmstbl_snippets","title","","istemplate",GetBoolean(True),"boolean"), conn, rs
	If Not rs.EOF Then
		Do Until rs.EOF
			int_templateid = rs("id")
			str_templatetitle = rs("title")
			
			Response.Write "<tr>" & vbCrLf
			DoDataOutput "acms_templateaction.asp?mode=1&amp;id=" & int_templateid & "&amp;action=movetofile","<img src=""images/admin/down.gif"" alt=""" & GetLanguage("lang_movetofile") & """ title=""" & GetLanguage("lang_movetofile") & """ />","","icon","td",""
			DoDataOutput "acms_templateedit.asp?mode=1&amp;id=" & int_templateid,Server.HTMLEncode(str_templatetitle),"","maincol smlindent","td",""
			DoDataOutput "acms_templateview.asp?mode=1&amp;id=" & int_templateid,"<img src=""images/admin/view.gif"" alt=""" & GetLanguage("lang_view") & """ title=""" & GetLanguage("lang_view") & """ />","","icon","td","templateview"
			DoDataOutput "acms_templateaction.asp?mode=1&amp;id=" & int_templateid & "&amp;action=duplicate","<img src=""images/admin/duplicate.gif"" alt=""" & GetLanguage("lang_duplicate") & """ title=""" & GetLanguage("lang_duplicate") & """ />","","icon","td",""
			DoDataOutput "javascript:confirmdelete('acms_templateaction.asp?mode=1&amp;id=" & int_templateid & "&amp;action=delete','" & str_templatetitle & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
			Response.Write "</tr>" & vbCrLf
			rs.MoveNext
		Loop
	End If
	CloseRecordset rs
	
End Sub

Sub DoFileTemplateList()

	Dim fs, folder, file_item, str_filename
		
	ReadDirectory "templates", fs, folder
	For Each file_item In folder.Files
		str_filename = file_item.Name
		Response.Write "<tr>" & vbCrLf
		DoDataOutput "acms_templateaction.asp?mode=2&amp;filename=" & str_filename & "&amp;action=movetodb","<img src=""images/admin/up.gif"" alt=""" & GetLanguage("lang_movetodatabase") & """ title=""" & GetLanguage("lang_movetodatabase") & """ />","","icon","td",""
		DoDataOutput "acms_templateedit.asp?mode=2&amp;filename=" & Server.URLEncode(str_filename),Server.HTMLEncode(str_filename),"","maincol smlindent","td",""
		DoDataOutput "acms_templateview.asp?mode=2&amp;filename=" & Server.URLEncode(str_filename),"<img src=""images/admin/view.gif"" alt=""" & GetLanguage("lang_view") & """ title=""" & GetLanguage("lang_view") & """ />","","icon","td","templateview"
		DoDataOutput "acms_templateaction.asp?mode=2&amp;filename=" & Server.URLEncode(str_filename) & "&amp;action=duplicate","<img src=""images/admin/duplicate.gif"" alt=""" & GetLanguage("lang_duplicate") & """ title=""" & GetLanguage("lang_duplicate") & """ />","","icon","td",""
		DoDataOutput "javascript:confirmdelete('acms_templateaction.asp?mode=2&amp;filename=" & Server.URLEncode(str_filename) & "&amp;action=delete','" & str_filename & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
		Response.Write "</tr>" & vbCrLf
	Next
	CloseFSO_Folder fs, folder

End Sub

Sub DoMainAdminContent ()
	OpenDatabase conn
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=GetLanguage("lang_menu_templates")%></div>
	<h2><%=GetLanguage("lang_databasetemplates")%></h2>
	<table class="tree">
		<tr>
			<td colspan="3" class="add"><a href="acms_templateedit.asp?mode=1"><%=GetLanguage("lang_adddatabasetemplate")%></a></td>
		</tr>
		<% DoDatabaseTemplateList %>
	</table>
	<h2><%=GetLanguage("lang_filetemplates")%></h2>
	<table class="tree">
		<tr>
			<td colspan="3" class="add"><a href="acms_templateedit.asp?mode=2"><%=GetLanguage("lang_addfiletemplate")%></a></td>
		</tr>
		<% DoFileTemplateList %>
	</table>
	<iframe name="templateview" src="acms_templateview.asp" class="content">
	
	</iframe>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<p>There are two types of templates; database and file.  Database templates are stored in the database, and file templates
		are stored on the server in the "templates" directory.  Both forms can be edited in the administration, and each have its
		own advantages and disadvantages.</p>
		<p>Due to security reasons, deleting files is not necessarily a viable option, but moving a template from a file to the database
		(and vice versa) can be done by pressing a button.  However, file templates mean that this file can be retrieved from the
		server, edited in a text or HTML editor and reuploaded without using the admin.</p>
		<p>Below is an explanation of the buttons shown in the page list.</p>
		<table class="tbl_instructions">
			<tr>
				<td><img src="images/admin/down.gif" alt="Down" title="Down" width="15" height="15" /></td>
				<td>Save the database template as a file</td>
			</tr>
			<tr>
				<td><img src="images/admin/up.gif" alt="Up" title="Up" width="15" height="15" /></td>
				<td>Save the file template into the database, the file template will be deleted if possible</td>
			</tr>
			<tr>
				<td><img src="images/admin/view.gif" alt="View" title="View" width="15" height="15" /></td>
				<td>Preview the content of the template</td>
			</tr>
			<tr>
				<td><img src="images/admin/duplicate.gif" alt="Duplicate" title="Duplicate" width="24" height="15" /></td>
				<td>Duplicate the snippet</td>
			</tr>
			<tr>
				<td><img src="images/admin/cross.gif" alt="Delete" title="Delete" width="15" height="15" /></td>
				<td>Delete the template from the server (if possible) or database</td>
			</tr>
		</table>
	</div>
<%
End Sub
%>