<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_usergroupaction.asp
' Summary  - Handles user groups actions
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("usergroups")

' variable declaration
Dim int_usergroupid, str_groupname, bln_locked, str_menuaccess, str_modaccess
Dim arr_menu, arr_modules
Dim str_action, str_redirect, str_msg
Dim conn, rs, i
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_users.asp"-->
<%

' get form values
str_action = GetValue("action","")
int_usergroupid = GetValue("id",0) 
str_groupname = GetValue("groupname","") 
bln_locked = GetValue("locked",False)
str_menuaccess = GetValue("menu","")
str_modaccess = GetValue("modules","")

OpenDatabase conn
Select Case lcase(str_action)

	Case "add"

		' Add data
		int_usergroupid = q_InsertUserGroup(conn,str_groupname,bln_locked)
		
		SplitValue str_menuaccess,arr_menu,", "
		For i = 0 To Ubound(arr_menu)
			q_InsertUserGroupAccess conn,int_usergroupid,arr_menu(i)
		Next
		
		SplitValue str_modaccess,arr_modules,", "
		For i = 0 To Ubound(arr_modules)
			q_InsertUserGroupAccess conn,int_usergroupid,arr_modules(i)
		Next
		
		str_redirect = "acms_usergroupedit.asp?id=" & int_usergroupid
		str_msg = GetLanguage("lang_usergroupadded")
			
	Case "update"
					
		' Update data
		q_UpdateUserGroup conn,int_usergroupid,str_groupname,bln_locked
		
		' Delete records from user group access
		ExecuteRecordset q_DeleteTable("acmstbl_usergroupaccess","usergroupid",int_usergroupid,"number"), conn, rs
		
		' Re-enter records to user group access
		SplitValue str_menuaccess,arr_menu,", "
		For i = 0 To Ubound(arr_menu)
			q_InsertUserGroupAccess conn,int_usergroupid,arr_menu(i)
		Next
		
		SplitValue str_modaccess,arr_modules,", "
		For i = 0 To Ubound(arr_modules)
			q_InsertUserGroupAccess conn,int_usergroupid,arr_modules(i)
		Next
		
		str_redirect = "acms_usergroupedit.asp?id=" & int_usergroupid
		str_msg = GetLanguage("lang_usergroupupdated")

	
	Case "delete"
		
		' Check for users
		ExecuteRecordset q_SelectTable("username","acmstbl_users","","","usergroup",int_usergroupid,"number"), conn, rs
		If Not rs.EOF Then
			CloseRecordset rs
			SetError "Cannot delete user group", "acms_usergrouplist.asp"
		End If
		CloseRecordset rs

		' Delete records from user group access
		ExecuteRecordset q_DeleteTable("acmstbl_usergroupaccess","usergroupid",int_usergroupid,"number"), conn, rs
		
		' Delete record
		ExecuteRecordset q_DeleteTable("acmstbl_usergroups","id",int_usergroupid,"number"), conn, rs
		
		str_redirect = "acms_usergrouplist.asp"
		str_msg = GetLanguage("lang_usergroupdeleted")
				
	Case "lock"
		
		' Update hide value to True/Yes/1
		q_UpdateBoolean conn,"acmstbl_usergroups","id",int_usergroupid,"locked",True
		str_redirect = "acms_usergrouplist.asp"
		
	Case "unlock"
		
		' Update hide value to False/No/0
		q_UpdateBoolean conn,"acmstbl_usergroups","id",int_usergroupid,"locked",False
		str_redirect = "acms_usergrouplist.asp"
	
	Case Else

End Select
CloseDatabase conn

If NotEmpty(str_msg) Then WriteSession "adminmessage", str_msg
If NotEmpty(str_redirect) Then Response.Redirect str_redirect
%>