<%
' *******************************************************************************
' AtomatiCMS
' Filename - acms_usergrouplist.asp
' Summary  - Lists the user groups in the database
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

OPTION EXPLICIT

Call ValidateUser("usergroups")

' variable declaration
Dim int_usergroupid, str_usergroupname, bln_locked
Dim conn
' end variables

' include files
%>
<!--#include file="includes/acmsi_global.asp"-->
<!--#include file="includes/acmsi_functions.asp"-->
<!--#include file="includes/acmsi_queries.asp"-->
<!--#include file="includes/acmsi_users.asp"-->
<!--#include file="includes/acmsi_admintemplate.asp"-->
<%
' end include files

' functions and subroutines
Sub DoUserGroupList()
	
	Dim rs, rs_users,str_usergroupclass
	
	If GetCookie("super") Then
		ExecuteRecordset q_SelectTable("id,groupname,locked","acmstbl_usergroups","groupname","","","",""), conn, rs
	Else
		ExecuteRecordset q_SelectTable("id,groupname,locked","acmstbl_usergroups","groupname","id<>" & GetCookie("usergroup"),"","",""), conn, rs
	End If
	If Not rs.EOF Then
		Do Until rs.EOF
			int_usergroupid = rs("id")
			str_usergroupname = rs("groupname")
			bln_locked = CBool(rs("locked"))
			
			Response.Write "<tr>" & vbCrLf
			DoDataOutput "acms_usergroupedit.asp?id=" & int_usergroupid,Server.HTMLEncode(str_usergroupname),"","maincol smlindent","td",""

			If bln_locked Then
				DoDataOutput "acms_usergroupaction.asp?id=" & int_usergroupid & "&amp;action=unlock","<img src=""images/admin/empty.gif"" alt=""" & GetLanguage("lang_unhide") & """ title=""" & GetLanguage("lang_unhide") & """ />","","icon","td",""
			Else
				DoDataOutput "acms_usergroupaction.asp?id=" & int_usergroupid & "&amp;action=lock","<img src=""images/admin/full.gif"" alt=""" & GetLanguage("lang_hide") & """ title=""" & GetLanguage("lang_hide") & """ />","","icon","td",""
			End If
			
			ExecuteRecordset q_SelectTable("username","acmstbl_users","","","usergroup",int_usergroupid,"number"), conn, rs_users
			If rs_users.EOF Then
				DoDataOutput "javascript:confirmdelete('acms_usergroupaction.asp?id=" & int_usergroupid & "&amp;action=delete','" & str_usergroupname & "')","<img src=""images/admin/cross.gif"" alt=""" & GetLanguage("lang_delete") & """ title=""" & GetLanguage("lang_delete") & """ />","","icon","td",""
			Else
				DoDataOutput "","&nbsp;","","icon","td",""
			End If
			CloseRecordset rs_users
			
			Response.Write "</tr>" & vbCrLf
			rs.MoveNext
		Loop
	End If
	
	CloseRecordset rs
	
End Sub
' end functions and subroutines

' admin template areas
Sub DoMainAdminContent ()
	OpenDatabase conn
%>
	<div class="breadcrumb"><a href="acms_adminhome.asp"><%=GetLanguage("lang_administration")%>...</a>&nbsp; <%=GetLanguage("lang_menu_usergroups")%></div>
	<table class="tree">
		<tr>
			<td colspan="3" class="add"><a href="acms_usergroupedit.asp"><%=GetLanguage("lang_addusergroup")%></a></td>
		</tr>
		<% DoUserGroupList %>
	</table>
<%
	CloseDatabase conn
End Sub

Sub DoAdminInstructions ()
%>
	<h2><%=GetLanguage("lang_instructions")%></h2>
	<div id="instructions">
		<p>Above shows a list of user groups that have been created; click on the group name to edit the details of the
		corresponding group. See below for explanations of the buttons shown in the page list.</p>
		<table class="tbl_instructions">
			<tr>
				<td><img src="images/admin/empty.gif" alt="Unhide" title="Unhide" width="15" height="15" /></td>
				<td>Indicates user group is currently locked; click to unlock the user group</td>
			</tr>
			<tr>
				<td><img src="images/admin/full.gif" alt="Hide" title="Hide" width="15" height="15" /></td>
				<td>Indicates user group is currently unlocked; click to lock the user group</td>
			</tr>
			<tr>
				<td><img src="images/admin/cross.gif" alt="Delete" title="Delete" width="15" height="15" /></td>
				<td>Delete user group and its users; user groups with users allocated to them cannot be deleted</td>
			</tr>
		</table>
	</div>
<%
End Sub
' end admin template areas
%>