<%
' *******************************************************************************
' AtomatiCMS
' Filename - acmsf_application.asp
' Summary  - General ACMS functions and subroutines
' Version  - 0.7B
' Updated  - 28 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

Sub WriteCookie(key,invalue)

	If NotEmpty(c_APPID) Then
		Response.Cookies("acms")(c_APPID & "_" & key) = invalue
	Else
		Response.Cookies("acms")(key) = invalue
	End If
	
End Sub

Function GetCookie(key)

	Dim outvalue
	If NotEmpty(c_APPID) Then
		outvalue = Request.Cookies("acms")(c_APPID & "_" & key)
	Else
		outvalue = Request.Cookies("acms")(key)
	End If
	
	GetCookie = outvalue

End Function

Sub WriteSession(key,invalue)

	RemoveSession key
	If NotEmpty(c_APPID) Then
		Session("acms_" & c_APPID & "_" & key) = invalue
	Else
		Session("acms_" & key) = invalue
	End If
	
End Sub

Function GetSession(key)

	Dim outvalue
	If NotEmpty(c_APPID) Then
		outvalue = Session("acms_" & c_APPID & "_" & key)
	Else
		outvalue = Session("acms_" & key)
	End If
	
	GetSession = outvalue

End Function

Sub RemoveSession(key)

	If NotEmpty(key) Then
		If NotEmpty(c_APPID) Then
			Session.Contents.Remove("acms_" & c_APPID & "_" & key)
		Else
			Session.Contents.Remove("acms_" & key)
		End If
	Else
		Session.Contents.RemoveAll()
	End If
	
End Sub

Sub WriteApplication(key,invalue)

	Application.Lock()
	If NotEmpty(c_APPID) Then
		Application("acms_" & c_APPID & "_" & key) = invalue
	Else
		Application("acms_" & key) = invalue
	End If
	Application.UnLock()
	
End Sub

Function GetApplication(key)

	Dim outvalue

	If NotEmpty(c_APPID) Then
		outvalue = Application("acms_" & c_APPID & "_" & key)
	Else
		outvalue = Application("acms_" & key)
	End If
	
	GetApplication = outvalue
	
End Function

Sub RemoveApplication(key)

	Dim i
	
	If Right(key,1)="*" Then
		key = Left(key,Len(key)-1)
		If NotEmpty(c_APPID) Then
			key = "acms_" & c_APPID & "_" & key
		Else
			key = "acms_" & key
		End If
		For Each i in Application.Contents
			If Left(i,Len(key)) = key Then Application.Contents.Remove(i)
		Next
	ElseIf NotEmpty(key) Then
		If NotEmpty(c_APPID) Then
			Application.Contents.Remove("acms_" & c_APPID & "_" & key)
		Else
			Application.Contents.Remove("acms_" & key)
		End If
	Else
		Application.Contents.RemoveAll()
	End If
	
End Sub

Function GetLanguage(invalue)

	Dim outvalue, fs, rs
	Dim str_language, str_langfilename
	
	If NotEmpty(GetCookie("langkeyword")) Then
		str_language = GetCookie("langkeyword")
		str_langfilename = GetCookie("langfilename")
	Else
		str_language = c_LANGUAGE
		ExecuteRecordset q_SelectTable("keyword","acmstbl_languages","","","keyword",str_language,"string"), conn, rs
		If Not rs.EOF Then str_langfilename = rs("keyword")
		CloseRecordset rs
	End If
	
	If NotEmpty(GetApplication(invalue & "(" & str_language & ")")) Then
	
		outvalue = GetApplication(invalue & "(" & str_language & ")")
		
	ElseIf NotEmpty(invalue) AND NotEmpty(GetCookie("langfilename")) Then
	
		OpenFSO fs
		If fs.FileExists(Server.MapPath("language/" & GetCookie("langfilename"))) Then
			Session("acms_appid") = c_APPID
			Server.Execute("language/" & GetCookie("langfilename"))
			Session.Contents.Remove("acms_appid")
			outvalue = GetApplication(invalue & "(" & str_language & ")")
		End If
		CloseFSO fs
	
	End If
	
	If outvalue = "" Then outvalue = invalue
	GetLanguage = outvalue

End Function

Function GetReferPage()

	Dim outvalue
	outvalue = Request.ServerVariables("HTTP_REFERER")
	If outvalue = "" Then outvalue = "acms_adminhome.asp"	
	GetReferPage = outvalue

End Function

Function GetDateTime(invalue,includetime)

	Dim int_year, int_month, int_day
	Dim str_time
	Dim outvalue
	
	outvalue = Year(invalue) & c_DATESEPARATOR & Month(invalue) & c_DATESEPARATOR & Day(invalue)
	If includetime Then outvalue = outvalue & " " & FormatDateTime(invalue,vblongtime)
	ReconstructDateTime = outvalue

End Function

Sub SetError(invalue,redirectto)

	WriteSession "adminerror", invalue
	If redirectto <> "" Then Response.Redirect redirectto

End Sub

Sub ShowError

	WriteSession "haserror", False
	If NotEmpty(GetSession("adminerror")) Then
		Response.Write "<p>" & Server.HTMLEncode(GetSession("adminerror")) & "</p>"
		RemoveSession "adminerror"
		WriteSession "haserror", True
	End If

End Sub

Sub ShowMessage

	If NotEmpty(GetSession("adminmessage")) Then
		If Not GetSession("haserror") Then Response.Write "<p>" & Server.HTMLEncode(GetSession("adminmessage")) & "</p>"
		RemoveSession "adminmessage"
		RemoveSession "haserror"
	End If

End Sub

Sub GoToErrorPage

	Response.Redirect c_ERRORPAGE

End Sub
%>