<%
' *******************************************************************************
' AtomatiCMS
' Filename - acmsi_queries.asp
' Summary  - Database SQL queries
' Version  - 0.5B
' Updated  - 15 January 2007
' (c) 2007 by Joseph Chang (joseph@atomaticsoftware.com)
' http://www.atomaticsoftware.com

' This file is part of AtomatiCMS.

' AtomatiCMS is free software; you can redistribute it and/or modify
' it under the terms of the GNU General Public License as published by
' the Free Software Foundation; either version 2 of the License, or
' (at your option) any later version.

' AtomatiCMS is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with AtomatiCMS; if not, write to the Free Software
' Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
' *******************************************************************************

Function q_SelectTable(columns,tables,orderby,where,fieldname,fieldvalue,fieldvaluetype)

	Dim str_sqlquery
	If columns = "" Then columns = "*"
	str_sqlquery = "SELECT " & columns & " FROM " & tables
	If NotEmpty(fieldname) Then
		str_sqlquery = str_sqlquery & " WHERE (" & fieldname & "=" & GetFieldValue(fieldvalue,fieldvaluetype) & ")"
		If NotEmpty(where) Then str_sqlquery = str_sqlquery & " AND " & where
	ElseIf NotEmpty(where) Then 
		str_sqlquery = str_sqlquery & " WHERE " & where
	End If
	
	If NotEmpty(orderby) Then str_sqlquery = str_sqlquery & " ORDER BY " & orderby
	q_SelectTable = str_sqlquery

End Function

Function q_SelectInnerJoin(columns,table,orderby,where,fieldname,fieldvalue,fieldvaluetype,table2,injoin,injoin2)

	Dim str_sqlquery
	If columns = "" Then columns = "*"
	str_sqlquery = "SELECT " & columns & " FROM " & table
	If NotEmpty(table2) Then str_sqlquery = str_sqlquery & " INNER JOIN " & table2 & " ON " & table & "." & injoin & "=" & table2 & "." & injoin2
	If NotEmpty(fieldname) Then
		str_sqlquery = str_sqlquery & " WHERE (" & table & "." & fieldname & "=" & GetFieldValue(fieldvalue,fieldvaluetype) & ")"
		If NotEmpty(where) Then str_sqlquery = str_sqlquery & " AND " & where
	ElseIf NotEmpty(where) Then 
		str_sqlquery = str_sqlquery & " WHERE " & where
	End If
	If NotEmpty(orderby) Then str_sqlquery = str_sqlquery & " ORDER BY " & orderby
	q_SelectInnerJoin = str_sqlquery

End Function

Function q_SelectMaxRecord(column,table,fieldname,fieldvalue,fieldvaluetype)

	Dim str_sqlquery
	str_sqlquery = "SELECT MAX(" & column & ") FROM " & table & " WHERE " & fieldname & "=" & GetFieldValue(fieldvalue,fieldvaluetype)
	q_SelectMaxRecord = str_sqlquery

End Function

Function q_SelectMaxRecordPlus(column,table,fieldname,fieldvalue,fieldvaluetype,where)

	Dim str_sqlquery
	str_sqlquery = "SELECT MAX(" & column & ") FROM " & table & " WHERE (" & fieldname & "=" & GetFieldValue(fieldvalue,fieldvaluetype) & ")"
	If NotEmpty(where) Then str_sqlquery = str_sqlquery & " AND (" & where & ")"
	q_SelectMaxRecordPlus = str_sqlquery

End Function

Function q_DeleteTable(table,fieldname,fieldvalue,fieldvaluetype)

	Dim str_sqlquery
	str_sqlquery = "DELETE FROM " & table & " WHERE " & fieldname & "=" & GetFieldValue(fieldvalue,fieldvaluetype)
	q_DeleteTable = str_sqlquery
	
End Function

Function q_InsertContent(conn,title,contentbody,ordinal,hide,parentid,pageid,setcontentname)

	Dim rs, str_sql
	Dim outvalue
	
	str_sql = "INSERT INTO acmstbl_content(title,contentbody,ordinal,hide,parentid,pageid,setcontentname)" &_
			" VALUES ('" & GetDBString(title) & "','" & GetDBString(contentbody) & "'," & ordinal & "," & GetBoolean(hide) & "," & parentid & "," & pageid & ",'" & GetDBString(setcontentname) & "');"

	conn.Execute(str_sql)
	
	str_sql = "SELECT @@IDENTITY AS id;"
	Set rs = conn.Execute(str_sql)
	outvalue = rs("id")
	CloseRecordset rs
	
	q_InsertContent = outvalue

End Function

Sub q_UpdateContentOrdinal(conn,contentid,pageid,ordinal,parentid,dir)

	Dim str_sql

	Select Case lcase(dir)
	
		Case "up"
			str_sql = "UPDATE acmstbl_content SET " &_
					"ordinal=" & ordinal-1 & " " &_
					"WHERE id=" & contentid & " " &_
					"AND pageid=" & pageid & " " &_
					"AND parentid=" & parentid & ";"
			conn.Execute(str_sql)
			
			str_sql = "UPDATE acmstbl_content SET " &_
					"ordinal=" & ordinal & " " &_
					"WHERE ordinal=" & ordinal-1 & " " &_
					"AND id<>" & contentid & " " &_
					"AND pageid=" & pageid & " " &_
					"AND parentid=" & parentid & ";"
			conn.Execute(str_sql)
	
		Case "down"
			str_sql = "UPDATE acmstbl_content SET " &_
					"ordinal=" & ordinal+1 & " " &_
					"WHERE id=" & contentid & " " &_
					"AND pageid=" & pageid & " " &_
					"AND parentid=" & parentid & ";"
			conn.Execute(str_sql)
			
			str_sql = "UPDATE acmstbl_content SET " &_
					"ordinal=" & ordinal & " " &_
					"WHERE ordinal=" & ordinal+1 & " " &_
					"AND id<>" & contentid & " " &_
					"AND pageid=" & pageid & " " &_
					"AND parentid=" & parentid & ";"
			conn.Execute(str_sql)
		
	End Select

End Sub

Sub q_DuplicateContent(conn,contentid,pageid,parentid)

	Dim rs, rs_new
	Dim str_fieldname
	
	OpenRecordset "SELECT * FROM acmstbl_content WHERE ID=" & contentid, conn, rs
	If Not rs.EOF Then
		OpenRecordset "acmstbl_content", conn, rs_new
		rs_new.AddNew
		For Each str_fieldname In rs.Fields
			Select Case lcase(str_fieldname.Name)
				Case "id"
				
				Case "ordinal"
					rs_new(str_fieldname.Name) = GetMaxValue("ordinal","acmstbl_content","pageid=" & pageid & " AND parentid=" & parentid) + 1
				
				Case "title"
					rs_new(str_fieldname.Name) = "Copy of " & rs(str_fieldname.Name)
					
				Case Else
					rs_new(str_fieldname.Name) = rs(str_fieldname.Name)
			End Select
		Next
		rs_new.Update
		CloseRecordset rs_new
	End If
	CloseRecordset rs

End Sub

Sub q_DuplicatePageContent(conn,pageid,oldpageid)

	Dim str_fieldname
	Dim rs, rs_new
	
	OpenRecordset "SELECT * FROM acmstbl_content WHERE pageid=" & oldpageid, conn, rs
	Do Until rs.EOF
		OpenTable "acmstbl_content", conn, rs_new
		rs_new.AddNew
		For Each str_fieldname In rs.Fields
			Select Case lcase(str_fieldname.Name)
				Case "id"
				
				Case "pageid"
					rs_new(str_fieldname.Name) = pageid
									
				Case Else
					rs_new(str_fieldname.Name) = rs(str_fieldname.Name)
					
			End Select
		Next
		rs_new.Update
		CloseRecordset rs_new
		rs.MoveNext
	Loop
	CloseRecordset rs

End Sub

Function q_InsertLanguage(conn,title,filename,keyword,disabled)

	Dim rs, str_sql
	Dim outvalue
			
	str_sql = "INSERT INTO acmstbl_languages(title,filename,keyword,disabled)" &_
			" VALUES ('" & GetDBString(title) & "','" & GetDBString(filename) & "','" & GetDBString(keyword) & "'," & GetBoolean(disabled) & ");"
	conn.Execute(str_sql)
	
	str_sql = "SELECT @@IDENTITY AS id;"
	Set rs = conn.Execute(str_sql)
	outvalue = rs("id")
	CloseRecordset rs
	
	q_InsertLanguage = outvalue

End Function

Sub q_UpdateLanguage(conn,languageid,title,filename,keyword,disabled)

	Dim str_sql
	
	str_sql = "UPDATE acmstbl_modules SET " &_
			"title='" & GetDBString(title) & "', " &_
			"filename='" & GetDBString(filename) & "', " &_
			"keyword='" & GetDBString(keyword) & "', " &_
			"disabled=" & GetBoolean(disabled) & " " &_
			"WHERE id=" & languageid & ";"
			
	conn.Execute(str_sql)

End Sub

Function q_InsertMenu(conn,title,filename,hide,parentid,core,keyword)

	Dim rs, str_sql
	Dim outvalue
			
	str_sql = "INSERT INTO acmstbl_menus(title,filename,hide,parentid,core,keyword)" &_
			" VALUES ('" & GetDBString(title) & "','" & GetDBString(filename) & "'," & GetBoolean(hide) & "," & parentid & "," & GetBoolean(core) & ",'" & GetDBString(keyword) & "');"
	conn.Execute(str_sql)
	
	str_sql = "SELECT @@IDENTITY AS id;"
	Set rs = conn.Execute(str_sql)
	outvalue = rs("id")
	CloseRecordset rs
	
	q_InsertMenu = outvalue

End Function

Sub q_UpdateMenu(conn,menuid,title,filename,hide,parentid,core,keyword)

	Dim str_sql
	
	str_sql = "UPDATE acmstbl_menus SET " &_
			"title='" & GetDBString(title) & "', " &_
			"filename='" & GetDBString(filename) & "', " &_
			"parentid=" & parentid & ", " &_
			"keyword='" & GetDBString(keyword) & "', " &_
			"core=" & GetBoolean(core) & ", " &_
			"hide=" & GetBoolean(hide) & " " &_
			"WHERE id=" & menuid & ";"
			
	conn.Execute(str_sql)

End Sub

Function q_InsertModule(conn,title,filename,calledfilename,modversion,keyword,disabled)

	Dim rs, str_sql
	Dim outvalue
			
	str_sql = "INSERT INTO acmstbl_modules(title,filename,calledfilename,version,keyword,disabled)" &_
			" VALUES ('" & GetDBString(title) & "','" & GetDBString(filename) & "','" & GetDBString(calledfilename) & "','" & GetDBString(modversion) & "','" & GetDBString(keyword) & "'," & GetBoolean(disabled) & ");"
	conn.Execute(str_sql)
	
	str_sql = "SELECT @@IDENTITY AS id;"
	Set rs = conn.Execute(str_sql)
	outvalue = rs("id")
	CloseRecordset rs
	
	q_InsertModule = outvalue

End Function

Sub q_UpdateModule(conn,moduleid,title,filename,calledfilename,modversion,keyword,disabled)

	Dim str_sql
	
	str_sql = "UPDATE acmstbl_modules SET " &_
			"title='" & GetDBString(title) & "', " &_
			"filename='" & GetDBString(filename) & "', " &_
			"calledfilename='" & GetDBString(calledfilename) & "', " &_
			"version='" & GetDBString(modversion) & "', " &_
			"keyword='" & GetDBString(keyword) & "', " &_
			"disabled=" & GetBoolean(disabled) & " " &_
			"WHERE id=" & moduleid & ";"
			
	conn.Execute(str_sql)

End Sub

Function q_InsertPage(conn,title,keyword,filename,url,ordinal,hide,template_db,template_file,parentid,modified,headtags)

	Dim rs, str_sql
	Dim outvalue
	
	str_sql = "INSERT INTO acmstbl_pages(title,keyword,filename,url,ordinal,hide,template_db,template_file,parentid,modified,headtags)" &_
			" VALUES ('" & GetDBString(title) & "','" & GetDBString(keyword) & "','" & GetDBString(filename) & "','" & GetDBString(url) & "'," & ordinal & "," & GetBoolean(hide) & "," &_
			template_db & ",'" & GetDBString(template_file) & "'," & parentid & "," & GetBoolean(modified) & ",'" & GetDBString(headtags) & "');"
	conn.Execute(str_sql)
	
	str_sql = "SELECT @@IDENTITY AS id;"
	Set rs = conn.Execute(str_sql)
	outvalue = rs("id")
	CloseRecordset rs
	
	q_InsertPage = outvalue

End Function

Sub q_UpdatePageOrdinal(conn,pageid,ordinal,parentid,dir)

	Dim str_sql
	
	Select Case lcase(dir)
	
		Case "up"
			str_sql = "UPDATE acmstbl_pages SET " &_
					"ordinal=" & ordinal-1 & " " &_
					"WHERE id=" & pageid & " " &_
					"AND parentid=" & parentid & ";"
			conn.Execute(str_sql)
			
			str_sql = "UPDATE acmstbl_pages SET " &_
					"ordinal=" & ordinal & " " &_
					"WHERE ordinal=" & ordinal-1 & " " &_
					"AND id<>" & pageid & " " &_
					"AND parentid=" & parentid & ";"
			conn.Execute(str_sql)
	
		Case "down"
			str_sql = "UPDATE acmstbl_pages SET " &_
					"ordinal=" & ordinal+1 & " " &_
					"WHERE id=" & pageid & " " &_
					"AND parentid=" & parentid & ";"
			conn.Execute(str_sql)
			
			str_sql = "UPDATE acmstbl_pages SET " &_
					"ordinal=" & ordinal & " " &_
					"WHERE ordinal=" & ordinal+1 & " " &_
					"AND id<>" & pageid & " " &_
					"AND parentid=" & parentid & ";"
			conn.Execute(str_sql)
		
	End Select

End Sub

Sub q_SetModifiedPage(conn,pageid,modified)

	Dim str_sql
	
	str_sql = "UPDATE acmstbl_pages SET " &_
			"modified=" & GetBoolean(modified) & " " &_
			"WHERE id=" & pageid & ";"
			
	conn.Execute(str_sql)

End Sub

Sub q_DuplicatePage(conn,pageid)

	Dim bln_keywordset, bln_filenameset, str_fieldname
	Dim str_keyword, str_filename
	Dim i, rs, rs_new, rs_keyword, rs_filename
	Dim int_newpageid
	
	ExecuteRecordSet q_SelectTable("*","acmstbl_pages","","","id",pageid,"number"), conn, rs
	If Not rs.EOF Then
		OpenTable "acmstbl_pages", conn, rs_new
		rs_new.AddNew
		For Each str_fieldname In rs.Fields
			Select Case lcase(str_fieldname.Name)
				Case "id"
					
				Case "keyword"
					bln_keywordset = False
					str_keyword = rs(str_fieldname.Name)
					i = 1
					Do Until bln_keywordset
						ExecuteRecordSet q_SelectTable("keyword","acmstbl_pages","","","keyword",str_keyword & "_copy_" & i,"string"), conn, rs_keyword
						If rs_keyword.EOF Then
							rs_new(str_fieldname.Name) = str_keyword & "_copy_" & i
							bln_keywordset = True
						Else
							i = i + 1
						End If
						CloseRecordset rs_keyword
					Loop
					
				Case "title"
					rs_new(str_fieldname.Name) = "Copy of " & rs(str_fieldname.Name)
					
				Case "filename"
					bln_filenameset = False
					str_filename = rs(str_fieldname.Name)
					i = 1
					If NotEmpty(str_filename) Then
						Do Until bln_filenameset
							ExecuteRecordSet q_SelectTable("filename","acmstbl_pages","","","filename","copy_" & i & "_" & str_filename,"string"), conn, rs_filename
							If rs_filename.EOF Then
								rs_new(str_fieldname.Name) = "copy_" & i & "_" & str_filename
								bln_filenameset = True
							Else
								i = i + 1
							End If
							CloseRecordset rs_filename
						Loop
					End If
					
				Case "ordinal"
					rs_new(str_fieldname.Name) = GetMaxValue("ordinal","acmstbl_pages","") + 1
				
				Case Else
					rs_new(str_fieldname.Name) = rs(str_fieldname.Name)
					
			End Select
		Next
		rs_new.Update
		int_newpageid = rs_new(0)
		CloseRecordset rs_new
		q_DuplicatePageContent conn, int_newpageid, pageid
	Else
		Exit Sub
	End If
	CloseRecordset rs
	
End Sub

Function q_InsertSnippet(conn,title,snippet,keyword,istemplate,hide)

	Dim rs, str_sql
	Dim outvalue
	
	str_sql = "INSERT INTO acmstbl_snippets(title,snippet,keyword,istemplate,hide)" &_
			" VALUES ('" & GetDBString(title) & "','" & GetDBString(snippet) & "','" & GetDBString(keyword) & "'," & GetBoolean(isTemplate) & "," & GetBoolean(hide) & ");"
	conn.Execute(str_sql)
	
	str_sql = "SELECT @@IDENTITY AS id;"
	Set rs = conn.Execute(str_sql)
	outvalue = rs("id")
	CloseRecordset rs
	
	q_InsertSnippet = outvalue

End Function

Sub q_UpdateSnippet(conn,templateid,title,snippet,keyword,istemplate,hide)

	Dim str_sql
	
	str_sql = "UPDATE acmstbl_snippets SET " &_
			"title='" & GetDBString(title) & "', " &_
			"snippet='" & GetDBString(snippet) & "', " &_
			"keyword='" & GetDBString(keyword) & "', " &_
			"istemplate=" & GetBoolean(istemplate) & ", " &_
			"hide=" & GetBoolean(hide) & " " &_
			"WHERE id=" & templateid & ";"
	conn.Execute(str_sql)

End Sub

Sub q_DuplicateSnippet(conn,snippetid)

	Dim bln_keywordset, str_fieldname
	Dim i, rs, rs_new, rs_keyword
	
	ExecuteRecordSet q_SelectTable("*","acmstbl_snippets","","","id",snippetid,"number"), conn, rs
	If Not rs.EOF Then
		OpenRecordset "acmstbl_snippets", conn, rs_new
		rs_new.AddNew
		For Each str_fieldname In rs.Fields
			Select Case lcase(str_fieldname.Name)
				Case "id"
				
				Case "keyword"
					bln_keywordset = False
					str_keyword = rs(str_fieldname.Name)
					i = 1
					Do Until bln_keywordset
						ExecuteRecordSet q_SelectTable("keyword","acmstbl_snippets","","","keyword",str_keyword & "_copy_" & i,"string"), conn, rs_keyword
						If rs_keyword.EOF Then
							rs_new(str_fieldname.Name) = str_keyword & "_copy_" & i
							bln_keywordset = True
						Else
							i = i + 1
						End If
						CloseRecordset rs_keyword
					Loop
					
				Case "title"
					rs_new(str_fieldname.Name) = "Copy of " & rs(str_fieldname.Name)
				
				Case Else
					rs_new(str_fieldname.Name) = rs(str_fieldname.Name)
					
			End Select
		Next
		rs_new.Update
		CloseRecordset rs_new
	Else
		Exit Sub
	End If
	CloseRecordset rs
	
End Sub

Sub q_DuplicateDBTemplate(conn,templateid)

	Dim bln_titleset, str_fieldname
	Dim str_titlename
	Dim i, rs, rs_new, rs_titlename
	
	ExecuteRecordSet q_SelectTable("*","acmstbl_snippets","","","id",templateid,"number"), conn, rs
	OpenTable "acmstbl_snippets", conn, rs_new
	rs_new.AddNew
	For Each str_fieldname In rs.Fields
		Select Case lcase(str_fieldname.Name)
			Case "id"
				
			Case "title"
				bln_titleset = False
				str_titlename = rs(str_fieldname.Name)
				i = 1
				If NotEmpty(str_titlename) Then
					Do Until bln_titleset
						ExecuteRecordSet q_SelectTable("title","acmstbl_snippets","","","title","copy_" & i & "_" & str_titlename,"string"), conn, rs_titlename
						If rs_titlename.EOF Then
							rs_new(str_fieldname.Name) = "copy_" & i & "_" & str_titlename
							bln_titleset = True
						Else
							i = i + 1
						End If
						CloseRecordset rs_titlename
					Loop
				End If
			
			Case Else
				rs_new(str_fieldname.Name) = rs(str_fieldname.Name)
				
		End Select
	Next
	rs_new.Update
	CloseRecordset rs_new
	CloseRecordset rs
	
End Sub

Sub q_InsertUser(conn,username,password,super,usergroup,locked)

	Dim str_sql
	Dim outvalue
	
	str_sql = "INSERT INTO acmstbl_users(username,userpassword,super,usergroup,locked)" &_
			" VALUES ('" & GetDBString(username) & "','" & GetDBString(password) & "'," & GetBoolean(super) & "," & usergroup & "," & GetBoolean(locked) & ");"

	conn.Execute(str_sql)
	
End Sub

Function q_InsertUserGroup(conn,groupname,locked)

	Dim rs, str_sql
	Dim outvalue
	
	str_sql = "INSERT INTO acmstbl_usergroups(groupname,locked)" &_
			" VALUES ('" & GetDBString(groupname) & "'," & GetBoolean(locked) & ");"
	conn.Execute(str_sql)
	
	str_sql = "SELECT @@IDENTITY AS id;"
	Set rs = conn.Execute(str_sql)
	outvalue = rs("id")
	CloseRecordset rs
	
	q_InsertUserGroup = outvalue
	
End Function

Sub q_InsertUserGroupAccess(conn,usergroupid,menukeyword)

	Dim str_sql
	Dim outvalue
	
	str_sql = "INSERT INTO acmstbl_usergroupaccess(usergroupid,menukeyword)" &_
			" VALUES (" & usergroupid & ",'" & GetDBString(menukeyword) & "');"
	conn.Execute(str_sql)
	
End Sub

Sub q_UpdateUserGroup(conn,usergroupid,groupname,locked)

	Dim str_sql
	
	str_sql = "UPDATE acmstbl_usergroups SET " &_
			"groupname='" & GetDBString(groupname) & "', " &_
			"locked=" & GetBoolean(locked) & " " &_
			"WHERE id=" & usergroupid & ";"
	conn.Execute(str_sql)

End Sub

Sub q_UpdateBoolean(conn,tablename,key,keyvalue,fieldname,fieldvalue)

	Dim str_sql
	str_sql = "UPDATE " & tablename & " SET " &_
			fieldname & "=" & GetBoolean(fieldvalue) & " " &_
			"WHERE " & key & "=" & GetDataType(keyvalue) & ";"
	conn.Execute(str_sql)

End Sub
%>